
 
from PIL import Image, ImageColor
from os import path as os_path, listdir as os_listdir, remove as os_remove
import time

from myLogger import LOG	
	
def fixAspectRatio(picpath, picpathout):
	start=time.time()
	LOG('fixAspectRatio]start-->%s' %picpath)
	color='black' # ImageColor.getrgb('#'+self.bgcolor[3:])
	im=Image.open(picpath)
	format=im.format
	if picpath.lower().endswith(('gif', 'bmp')):
		LOG('fixAspectRatio]checkOrientation is for gif or bmp not supported...')
		rotatedandresized=False
	else:
		im, rotatedandresized=checkOrientation(im)
		
	x,y=im.size
	if rotatedandresized:
		LOG('fixAspectRatio]size x-->%s y-->%s rotatedandresized-->%s' %(y, x, str(rotatedandresized)))
		if x/16.0>y/9.0:
			LOG('fixAspectRatio]Image is lower as 16:9')
			x_new=x
			y_new=16.0/9*y
			x_paste_pos=0
			y_paste_pos=(y_new-y)/2
			
		else:#x<y
			LOG('fixAspectRatio]Image is higher as 19:9')
			x_new=16.0/9*y
			y_new=y
			x_paste_pos=(x_new-x)/2
			y_paste_pos=0

		LOG('fixAspectRatio]start fixing aspect now...')
		im1=Image.new('RGB',(int(x_new),int(y_new)), color)
		im1.paste(im,(int(x_paste_pos), int(y_paste_pos)),)
		im1.save(picpathout, format)
		LOG('fixAspectRatio]done %s' %(time.time() -start))
		
		return picpathout

	else: # not rotated
		LOG('fixAspectRatio]size x-->%s y-->%s rotatedandresized-->%s' %(x, y,str(rotatedandresized)))
		if x/16-y/9 <2 and x/16-y/9>-2: # this is ok
			LOG('fixAspectRatio]Image is 16:9')
			im=myresize(im)
			im.save(picpathout, format)
			LOG('fixAspectRatio]done %s' %(time.time() -start))
			
			return picpathout
			
		elif x/16.0>y/9.0:
			LOG('fixAspectRatio]Image is lower as 16:9')
			f=x/1920.0
			x=int(x/f)
			y=int(y/f)
			im=myresize(im)
			x,y=im.size
			x1=int(x)
			y1=int(x/16.0*9)
			
		else:#x<y
			LOG('fixAspectRatio]Image is higher as 19:9')
			f=y/1080.0
			x=int(x/f)
			y=int(y/f)
			im=myresize(im)
			x,y=im.size
			x1=int(y/9.0*16.0)
			y1=int(y)
			
		LOG('fixAspectRatio]start fixing aspect now...')
		im1=Image.new('RGB',(x1,y1), color)
		im1.paste(im,((x1-x)/2,(y1-y)/2))
		im1.save(picpathout, format)
		LOG('fixAspectRatio]done fixing aspect x-->%s y-->%s' %(im1.size))
		LOG('fixAspectRatio]done %s' %(time.time() -start))
		
		return picpathout

def myresize(im, ishorizontal=True):
	x,y=im.size
	if ishorizontal:
		LOG('myresize]horizontal start x->%s y->%s' %(x,y))
		if x>1920 or y>1080:
			f=y/1080.0
			n_x=int(x/f)
			n_y=int(y/f)
			if im.format not in ('GIF','BMP'):
				im.draft('RGB',(n_x, n_y))
				
	else:
		LOG('myresize]vertikal start x->%s y->%s' %(x,y))
		if x>1080 or y>607:
			f=y/607.0
			n_x=int(x/f)
			n_y=int(y/f)
			LOG('myresize]draft now to x->%d y->%d' %(n_x, n_y))
			if im.format not in ('GIF','BMP'):
				im.draft('RGB',(n_x, n_y))
	
	LOG('myresize] finish x->%d y->%d' %(im.size))
	return im

def checkOrientation(im):
	# The EXIF tag that holds orientation data.
	EXIF_ORIENTATION_TAG = 274

	# Obviously the only ones to process are 3, 6 and 8.
	# All are documented here for thoroughness.
	ORIENTATIONS = {
		1: ("Normal", 0),
		2: ("Mirrored left-to-right", 0),
		3: ("Rotated 180 degrees", 180),
		4: ("Mirrored top-to-bottom", 0),
		5: ("Mirrored along top-left diagonal", 0),
		6: ("Rotated 90 degrees", -90),
		7: ("Mirrored along top-right diagonal", 0),
		8: ("Rotated 270 degrees", -270)
	}
	exif=im._getexif()
	if exif:
		if exif.has_key(EXIF_ORIENTATION_TAG):
			orientation = exif[EXIF_ORIENTATION_TAG]
			LOG('PicturePlayer2]checkOrientation] orientation is->%s' %orientation)
			exif={}
			if orientation in [3,6,8]:
				# rotate now...	
				degrees = ORIENTATIONS[orientation][1]
				if orientation in [3,]:
					ishorizontal=True
				else:
					ishorizontal=False
				LOG('PicturePlayer2]checkOrientation]rotate degrees ->%s ishorizontal-->%s' %(degrees, ishorizontal))
				im= myresize(im, ishorizontal)
				im=im.rotate(degrees)
				return im, True
				
		else:
			LOG('PicturePlayer2]checkOrientation]no orientation found')
			exif={}
	else:
		LOG('PicturePlayer2]checkOrientation]no exif found')
		exif={}
		
	return im, False
