# -*- coding: UTF-8 -*-

# pictureplayer2 E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

# based on original pictureplayer 

from Plugins.Plugin import PluginDescriptor
from Components.config import config, ConfigSubsection, ConfigInteger, ConfigSelection, ConfigText, ConfigOnOff, ConfigDirectory
from Tools.Directories import resolveFilename, pathExists, fileExists, SCOPE_MEDIA

import pictureplayer2


config.pic2 = ConfigSubsection()
config.pic2.framesize = ConfigInteger(default=30, limits=(0, 99))
config.pic2.slidetime = ConfigInteger(default=10, limits=(5, 60))
config.pic2.resize = ConfigSelection(default="2", choices = [("0", _("simple")), ("1", _("better")), ("2", _("fast JPEG"))])
#config.pic2.resize.value = 2 # 2 = fast JPEG (non JPEG fallback to 1)
config.pic2.cache = ConfigOnOff(default=True)
config.pic2.lastDir = ConfigText(default=resolveFilename(SCOPE_MEDIA))
config.pic2.infoline = ConfigOnOff(default=True)
config.pic2.loop = ConfigOnOff(default=True)
config.pic2.bgcolor = ConfigSelection(default="#00000000", choices = [("#00000000", _("black")),("#009eb9ff", _("blue")),("#00ff5a51", _("red")), ("#00ffe875", _("yellow")), ("#0038FF48", _("green"))])
config.pic2.textcolor = ConfigSelection(default="#0038FF48", choices = [("#00000000", _("black")),("#009eb9ff", _("blue")),("#00ff5a51", _("red")), ("#00ffe875", _("yellow")), ("#0038FF48", _("green"))])
config.pic2.thumbDelay = ConfigInteger(default=500, limits=(0,999))
config.pic2.fadeDelay = ConfigInteger(default=400, limits=(0,1500))
config.pic2.pichome = ConfigDirectory(default="/media/hdd/")

#------------------------------------------------------------------------------------------

def main(session, **kwargs):
	reload(pictureplayer2)
	session.open(pictureplayer2.picshow2)
	
def filescan_open(list, session, **kwargs):
	reload(pictureplayer2)
	# Recreate List as expected by PicView
	filelist = [((file.path, False), None) for file in list]
	session.open(pictureplayer2.Pic_Full_View2, filelist, 0, file.path)

def filescan(**kwargs):
	from Components.Scanner import Scanner, ScanPath

	# Overwrite checkFile to only detect local
	class LocalScanner(Scanner):
		def checkFile(self, file):
			return fileExists(file.path)

	return \
		LocalScanner(mimetypes = ["image/jpeg", "image/png", "image/gif", "image/bmp"],
			paths_to_scan = 
				[
					ScanPath(path = "DCIM", with_subdirs = True),
					ScanPath(path = "", with_subdirs = False),
				],
			name = "Pictures", 
			description = _("View Photos..."),
			openfnc = filescan_open,
		)

def menu_pictureplayer2(menuid, **kwargs):
	if menuid == "mainmenu":
		return [(_("Picture Player 2"), 
		main, "Dreambox Picture Player v2", 31)]
	return []


def Plugins(**kwargs):
	list=[PluginDescriptor(name=_("Picture Player 2"), description=_("fileformats (BMP, PNG, JPG, GIF)"), icon="pictureplayer.png", where = PluginDescriptor.WHERE_PLUGINMENU, needsRestart = False, fnc=main)]
	list.append(PluginDescriptor(name=_("Picture Player 2"), where = PluginDescriptor.WHERE_FILESCAN, needsRestart = False, fnc = filescan))
	list.append(PluginDescriptor(name="Picture Player 2", description=_("Dreambox Picture Player v2"), where=[PluginDescriptor.WHERE_MENU], fnc=menu_pictureplayer2))
	return list	
